/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.geronimo.samples.datacdinfo.web;

import java.io.IOException;

import javax.ejb.EJB;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.geronimo.samples.datacdinfo.core.DataCDInfoAdminLocal;

/**
 * Servlet implementation class DataCDInfoAdminServlet
 * 
 * This servlet is used to demo security annotation usage on EJB.
 */
public class DataCDInfoAdminServlet extends HttpServlet {
    private static final long serialVersionUID = 1L;

    @EJB
    private DataCDInfoAdminLocal admin = null;

    /**
     * @see HttpServlet#HttpServlet()
     */
    public DataCDInfoAdminServlet() {
        super();
        // TODO Auto-generated constructor stub
    }

    /**
     * @see Servlet#init(ServletConfig)
     */
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
    }

    /**
     * @see Servlet#destroy()
     */
    public void destroy() {
        // TODO Auto-generated method stub
    }

    /**
     * @see HttpServlet#service(HttpServletRequest request, HttpServletResponse
     *      response)
     */
    protected void service(HttpServletRequest request,
            HttpServletResponse response) throws ServletException, IOException {
        String action = request.getParameter("action");

        if (action.equals("listOwners")) {
            String[] owners = admin.listOwners();
            request.setAttribute("owners", owners);

            this.getServletConfig().getServletContext().getRequestDispatcher("/admin/showOwners.jsp").include(request, response);
        }

        if (action.equals("listCDs")) {
            String[] cds = admin.listAllDataCDs();
            request.setAttribute("cds", cds);

            this.getServletConfig().getServletContext().getRequestDispatcher("/admin/showCDs.jsp").include(request, response);

        }

        if (action.equals("findpasswd")) {
            String ownername = request.getParameter("ownername");
            String passwd = admin.findpasswd(ownername);
            request.setAttribute("passwd", passwd);
            request.setAttribute("ownername", ownername);

            this.getServletConfig().getServletContext().getRequestDispatcher("/admin/showPasswd.jsp").include(request, response);
        }
    }

    /**
     * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse
     *      response)
     */
    protected void doGet(HttpServletRequest request,
            HttpServletResponse response) throws ServletException, IOException {
        service(request, response);
    }

    /**
     * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse
     *      response)
     */
    protected void doPost(HttpServletRequest request,
            HttpServletResponse response) throws ServletException, IOException {
        service(request, response);
    }

}
